#include <stdlib.h>
#include "ObjCore.h"
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "lst.h"
#include "RtStrings.h"
#include "build_option.h"

#ifndef _MENU_H
#define _MENU_H

#define CHUNKSIZE	15	/* initial number of slot in the menu */
				/* table. Add chunks of 15 if needed  */

typedef struct _MenuClassPart {
    int foo;  
} MenuClassPart;

typedef struct _MenuClassRec {
    ObjCoreClassPart core_class;
    MenuClassPart menu_class;
} MenuClassRec;

extern  MenuClassRec   	menuClassRec;
extern  ObjClass 	menuObjClass;

typedef struct _MenuPart {
   MenuItem *menutbl;	/* menu definition table  		  */
   int tblsiz;		/* table size				  */
   int	  cnt;		/* number of used slots 		  */   
} MenuPart;

/*
 * Menu record
 */

typedef struct _MenuRec { 
   ObjCorePart core;
   RtWidgetPart widget;
   MenuPart menu;
} MenuRec;


typedef MenuRec  		*MenuObj;
typedef MenuClassRec		*MenuObjClass;

#ifndef _RT_SET_VALUE
#define _RT_SET_VALUE

#define RtSetValue(obj,res,value) \
{ \
Obj new;\
ObjClass class; \
   class = obj->core.widget_class; \
   new = (Obj) malloc (class->core_class.widget_size); \
   if (!new || !obj) \
     return; \
   res = value; \
   memcpy (new, obj, class->core_class.widget_size);\
   res = value; \
   RtSetObjectValues (obj, new);\
}


#define RtGetValue(obj,res,value_pointer) \
{ \
Obj new;\
   if (!obj) \
     return; \
   new = obj;\
   *value_pointer = res; \
}
#endif
#endif
