
/*
 * Freedom Desktop 
 * Copyright 1994 by Freedom Software
 *
 * Freedom Software retains all rights to Freedom Desktop (hereafter Software)
 * in binary and in source code form.
 * 
 * The commercial use of this Software shall be governed by a separate License 
 * agreement. Any individual or institution wishing to make commercial use of 
 * the Software must sign a license agreement with Freedom Software. In such 
 * cases, the Licensee agrees to abide by the terms contained in the License
 * Agreement and not those contained in this document. Examples of commercial
 * use include (without limitation): (i) integration of the Software (source
 * code form), in whole or in part, into a commercial product sold by or on
 * on behalf of the Licensee; (ii) distribution of the Software (binary form or
 * source code form) in combination with a commercial product sold by or on
 * behalf the Licensee.
 *
 * Freedom Software (Licensor) grants you (Licensee) a license: (i) to use,
 * copy and make changes and improvements to this Software for licensee's 
 * internal business purposes; (ii) to use, copy, and distribute this Software 
 * or the derivative works provided that the copyright notice and this 
 * permission notice appear on all copies and that NO CHARGE is associated 
 * with such copies. However, if Licensee distributes any derivative work 
 * based on the Software, then Licensee shall (i) notify Licensor in writing 
 * (ii) clearly state that such derivative work is a modified and not the 
 * original Freedom Desktop distributed by Freedom Software (iii) publish
 * the corresponding machine-readable source code or information as to
 * where it may be obtained. Each time Licensee redistribute the Software
 * or any derivative work, the recipient automatically agrees to abide 
 * by the same terms as the Licensee. Licensee may not impose terms
 * more restrictive than the terms granted herein.
 * 
 * By using, copying, modifying or distributing this Software (or any 
 * derivative work based on this Software) Licensee indicates acceptance 
 * of the terms and conditions set forth in this License.
 *
 * Licensor reserves the right to terminate this License immediately on written
 * notice, for material breach by the Licensee.
 *
 * FREEDOM SOFTWARE DISCLAIMS ALL WARRANTIES EXPRESS OR IMPLIED WITH REGARD 
 * TO THE SOFTWARE INCLUDING BUT NOT LIMITED TO ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND  FITNESS,  IN  NO  EVENT  SHALL LICENSOR BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE
 */

#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/MainW.h>
#include <Xm/ScrolledW.h>


/*
 * Callbacks and external functions
 */

extern void createScrolledWindow();

/* Create main window */

Widget CreatemainWindow(parent)
Widget parent;
{
    Arg    		args[20];
    Widget		mainWindow;
    register    int    	argcnt;
    Widget		form;
    Widget		scrolledWindow;


    XmRegisterConverters();
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 475); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 146); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;

    mainWindow = XtCreateWidget ("mainWindow", xmMainWindowWidgetClass, parent,
		args,
		argcnt);

 
    argcnt = 0;

    XtSetArg (args[argcnt], XmNwidth, 475); argcnt++;
    XtSetArg (args[argcnt], XmNheight, 146); argcnt++;

    form = XtCreateWidget ("form", xmFormWidgetClass, mainWindow, args,
		argcnt);

    XtManageChild(form);
 
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 475); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 146); argcnt++;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarDisplayPolicy, XmSTATIC); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    scrolledWindow = XtCreateWidget ("scrolledWindow",
		xmScrolledWindowWidgetClass, form, args, argcnt);

    createScrolledWindow (scrolledWindow, (caddr_t)0, (caddr_t)0);
    XtManageChild (scrolledWindow);

    return (mainWindow);
}

