
/*
 * Freedom Desktop
 * Copyright 1994 by Freedom Software
 *
 * Freedom Software retains all rights to Freedom Desktop (hereafter Software)
 * in binary and in source code form.
 *
 * The commercial use of this Software shall be governed by a separate License
 * agreement. Any individual or institution wishing to make commercial use of
 * the Software must sign a license agreement with Freedom Software. In such
 * cases, the Licensee agrees to abide by the terms contained in the License
 * Agreement and not those contained in this document. Examples of commercial
 * use include (without limitation): (i) integration of the Software (source
 * code form), in whole or in part, into a commercial product sold by or on
 * on behalf of the Licensee; (ii) distribution of the Software (binary form or
 * source code form) in combination with a commercial product sold by or on
 * behalf of the Licensee.
 *
 * Freedom Software (Licensor) grants you (Licensee) a license: (i) to use,
 * copy and make changes and improvements to this Software for licensee's
 * internal business purposes; (ii) to use, copy, and distribute this Software
 * or the derivative works provided that the copyright notice and this
 * permission notice appear on all copies and that NO CHARGE is associated
 * with such copies. However, if Licensee distributes any derivative work
 * based on the Software, then Licensee shall (i) notify Licensor in writing
 * (ii) clearly state that such derivative work is a modified and not the
 * original Freedom Desktop distributed by Freedom Software (iii) publish
 * the corresponding machine-readable source code or information as to
 * where it may be obtained. Each time Licensee redistribute the Software
 * or any derivative work, the recipient automatically agrees to abide
 * by the same terms as the Licensee. Licensee may not impose terms
 * more restrictive than the terms granted herein.
 *
 * By using, copying, modifying or distributing this Software (or any
 * derivative work based on this Software) Licensee indicates acceptance
 * of the terms and conditions set forth in this License.
 *
 * Licensor reserves the right to terminate this License immediately on written
 * notice, for material breach by the Licensee.
 *
 * FREEDOM SOFTWARE DISCLAIMS ALL WARRANTIES EXPRESS OR IMPLIED WITH REGARD
 * TO THIS SOFTWARE INCLUDING BUT NOT LIMITED TO ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND  FITNESS,  IN  NO  EVENT  SHALL LICENSOR BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE
 */

#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/Text.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/LabelG.h>
#include <Xm/CascadeB.h>

#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <signal.h>


#include "lst.h"
#include "Dir.h"
#include "Xsh.h"
#include "X.h"
#include "xentry_form.h"
#include "XedwList.h"
#include "build_option.h"
#include "etc.h"
#include "file.h"
#include "Openscript.h"



extern char *_homepath;
extern char *_freedompath;	/* Path to .freedom under the home directory */
extern char *_lgroupspath;	/* Path to the Groups directory              */
extern char *_lfreedompath;	/* Path to the Freedom Software directory    */
extern char *_groupsname;	/* Name of the Group directory               */
extern char *_maingroup;	/* Name of the main group directory          */
static char *_startgroup = "Startup";	/* Name of the startup group directory       */
static char *lstartpath;	/* Path of the Startup group                 */
/*
 * _CreateASubMenu: create the actions submenu (submenu of the popup menu)
 */

/*
 * _ActionMenuDelItems: destroy all widgets in the actions menu
 */

_ActionMenuDelItems (w)
register Widget *w;
{
   Widget menu;
   
   menu = _XmCGetSubmenu (w);
   
   if (!menu) {
#ifdef DEBUG
	fprintf (stderr, "XpmActionMenuDelItems: _XmCGetSubmenu failed\n"); 
#endif
	return;
   
   }
   _XmCTraverseChildren (menu, XtDestroyWidget, NULL);      
}

void _CreateASubMenu (dw, actions_cascade)
Widget dw;
Widget actions_cascade;
{
   int cnt;
   
   cnt = XwDirSelectedItemCount (dw);
   
   if (cnt != 1) {
	XtSetSensitive (actions_cascade, False);
        _ActionMenuDelItems (actions_cascade);
        return;
   }
   
   _ActionMenuDelItems (actions_cascade);
   XwDirActionMenuAddItems (dw, actions_cascade, _SKIP_CREATION);
   if (!XwDirIfDefActions (dw))
	XtSetSensitive (actions_cascade, False);
   else   	   
	XtSetSensitive (actions_cascade, True);

}

